// $Id: CassetteDevice.hh,v 1.2 2002/08/03 19:23:47 m9710797 Exp $

#ifndef __CASSETTEDEVICE_HH__
#define __CASSETTEDEVICE_HH__

#include "Pluggable.hh"

// forward declarations
class EmuTime;


class CassetteDevice : public Pluggable
{
	public:
		/**
		 * Sets the cassette motor relay
		 *  false = off   true = on
		 */
		virtual void setMotor(bool status, const EmuTime &time) = 0;
		
		/**
		 * Read wave data from cassette device
		 */
		virtual short readSample(const EmuTime &time) = 0;
		
		/**
		 * Write wave data to cassette device
		 */
		virtual void writeWave(short *buf, int length) = 0;
		
		/**
		 * Returns the sample rate of the writeWave() wave form.
		 * A sample rate of 0 means this CassetteDevice is not interested
		 * in writeWave() data (iow is not recording).
		 */
		virtual int getWriteSampleRate() = 0;


		virtual const std::string &getClass();
};

#endif
